package webapps.ajax1.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.*;
import java.util.*;
import com.google.gson.*;
import java.io.InputStream;
import webapps.ajax1.entities.*;
import webapps.ajax1.model.*;

/**
 * Servlet para realizar queries genericos sobre la b.d. firebird
 * y devolver resultado de query en formato JSON
 * 
 * @author G.Cherencio.
 * @version 1.7
 */
@WebServlet(name = "JsonQueryServlet", urlPatterns = {"/query"})
public class JsonQueryServlet  extends HttpServlet {
    private static FBCon fb1 = FBCon.getFBCon(1);
    
    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html");
        String query = request.getParameter("query");
        System.out.println("Servlet JsonQueryServlet recibe query="+query);
       
        PrintWriter out = response.getWriter();
        
        try {
            
            //JSonTable<Test> jst = new JSonTable<Test>();
            ResultSet rs = fb1.getResultSet(query);
            ResultSetMetaData rsmd = rs.getMetaData();
            int nc = rsmd.getColumnCount();
            String colNames[] = new String[nc];
            for(int i=1;i<=nc;i++) colNames[i-1] = rsmd.getColumnName(i).toLowerCase();
            StringBuilder sb = new StringBuilder("[");
            boolean pase0 = false;
            while(rs.next()) {
                if ( pase0 ) sb.append(",");
                sb.append("{");
                boolean pase = false;
                for(String cn : colNames) {
                    if ( pase ) sb.append(",");
                    sb.append("\""+cn+"\":\""+rs.getString(cn)+"\"");
                    pase=true;
                }
                sb.append("}");
                pase0=true;
            }
            fb1.close(rs);
            sb.append("]");
            //trace
            System.out.println("JsonQueryServlet result="+sb.toString()+"=");
            out.write(sb.toString());
        } catch(java.sql.SQLException e) {
            //trace
            System.out.println("JsonQueryServlet SQL ERROR="+e.getMessage()+"=");
            out.write("[]");
        } finally {
            out.close();
        }
        //trace
        System.out.println("JsonQueryServlet FIN!!");
    }
    
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "JsonQueryServlet, servlet generico para consulta b.d., devuelve json";
    }// </editor-fold>
    
}
