package webapps.ajax1.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.*;
import java.util.*;
import java.text.*;
import com.google.gson.Gson;
import webapps.ajax1.model.*;

/**
 *
 * Agregar libreria google gson a preferences - libraries
 * salir de bluej y volver a entrar
 * 
 * @author grchere
 */
@WebServlet(name = "JsonServlet", urlPatterns = {"/JsonServlet","/JsonServletDelete","/JsonServletUpdate","/JsonServletDates"})
public class JsonServlet extends HttpServlet {
    private static FBCon fb0 = FBCon.getFBCon(0); // test
    private static FBCon fb1 = FBCon.getFBCon(1); // isft
    
    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //response.setContentType("application/json");
        response.setContentType("text/html");
        //Gson gson = new Gson(); // por ahora no es necesario

        PrintWriter out = response.getWriter();
        
        if ( request.getRequestURI().toLowerCase().endsWith("/jsonservlet") ) { // INSERT!!!
            String descripcion = request.getParameter("descr");
            System.out.println("Servlet JsonServlet recibe descr="+descripcion);
            try {
                ResultSet rs = fb0.getResultSet("SELECT COALESCE( MAX(ID), 0)+1 FROM TEST");
                rs.next();
                int nid = rs.getInt(1);
                fb0.executeQuery(rs.getStatement(),"INSERT INTO TEST VALUES("+nid+",'"+descripcion+"','TODAY')");
                out.println("<b>"+descripcion+"</b> insertado Ok!");
                fb0.close(rs);
            } catch(java.sql.SQLException e) {
                System.err.println("Error sql: "+e.getMessage());
                out.println("<b>"+descripcion+"</b> ERROR! "+e.getMessage());
            }
        }
        if ( request.getRequestURI().toLowerCase().endsWith("/jsonservletdelete") ) { // DELETE!!!
            String id = request.getParameter("id");
            System.out.println("Servlet JsonServlet recibe id="+id);
            try {
                fb0.executeQuery("DELETE FROM TEST WHERE ID = "+id);
                out.println("<b>"+id+"</b> borrado Ok!");
            } catch(java.sql.SQLException e) {
                System.err.println("Error sql: "+e.getMessage());
                out.println("<b>"+id+"</b> ERROR! "+e.getMessage());
            }
        }
        if ( request.getRequestURI().toLowerCase().endsWith("/jsonservletupdate") ) { // UPDATE!!!
            String id = request.getParameter("id");
            String descr = request.getParameter("descr");
            String sfecha = request.getParameter("fecha");
            SimpleDateFormat sdfin = new SimpleDateFormat("dd/MM/yyyy"); // formato de fecha de entrada
            SimpleDateFormat sdfout = new SimpleDateFormat("dd-MMM-yy",Locale.US); // formato de fecha de FB
            java.util.Date fecha = null;
            try {
                fecha = sdfin.parse(sfecha);
            } catch(Exception e) {
            }
            String strFecha = null;
            if ( fecha == null ) {
                strFecha = sdfout.format(new java.util.Date());
            } else {
                strFecha = sdfout.format(fecha);
            }
            System.out.println("Servlet JsonServlet recibe id="+id+" descr="+descr+" fecha="+sfecha);
            System.out.println("Servlet JsonServlet strFecha="+strFecha);
            int rows=0;
            try {
                rows=fb0.executeQuery("UPDATE TEST SET DESCR='"+descr+"',FECHA='"+strFecha+"' WHERE ID = "+id);
                if ( rows == 1 ) out.println("<b>"+id+"</b> actualizado Ok!");
                else             out.println("<b>"+id+"</b>  no encontrado!");
            } catch(java.sql.SQLException e) {
                System.err.println("Error sql: "+e.getMessage());
                out.println("<b>"+id+"</b> ERROR! "+e.getMessage());
            }
        }
        if ( request.getRequestURI().toLowerCase().endsWith("/jsonservletdates") ) { // FECHA DESDE-HASTA QUERY!!!
            java.util.Date desde = new java.util.Date(new Long(request.getParameter("desde")));
            java.util.Date hasta = new java.util.Date(new Long(request.getParameter("hasta")));
            SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
            SimpleDateFormat sdff = new SimpleDateFormat("dd-MMM-yyyy",Locale.US);
            String sdesde = sdf.format(desde);
            String shasta = sdf.format(hasta);
            String sfdesde = sdff.format(desde);
            String sfhasta = sdff.format(hasta);
            Calendar cdesde = Calendar.getInstance();
            Calendar chasta = Calendar.getInstance();
            cdesde.setTime(desde);
            chasta.setTime(hasta);
            System.out.println("Servlet JsonServlet recibe desde="+sdesde+" hasta="+shasta);
            StringBuffer sb = new StringBuffer();
            try {
                ResultSet rs = fb1.getResultSet("SELECT IDM,FECHA,CODIGOM FROM TBL_MESAEX WHERE ESTADO = 'C' AND "+
                                                "FECHA BETWEEN '"+sfdesde+"' AND '"+sfhasta+"'");
                sb.append("{\"Result\":\"OK\",\"Records\":[");
                boolean firstr=true;
                while(rs.next()) {
                    if (!firstr) sb.append(",");
                    else firstr = false;
                    sb.append("{\"idm\":"+rs.getInt("idm")+
                                ",\"fecha\":\"\\/Date("+rs.getDate("fecha").getTime()+")\\/\""+
                                ",\"codigom\":"+rs.getInt("codigom")+"}");
                }
                sb.append("]}");
                fb1.close(rs);
            } catch(java.sql.SQLException e) {
                System.err.println("Error sql: "+e.getMessage());
                sb.delete(0,sb.length());
                sb.append("{\"Result\":\"ERROR\",\"Message\":\""+e.getMessage()+"\"");
            }
            System.out.println("Servlet JsonServlet devuelve:");
            System.out.println(sb.toString());
            out.print(sb.toString());
        }
        out.close();
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
